<template>
  <VeeInput
    v-if="filter.type === FilterType.Date"
    :name="filter.name"
    :label="filter.label"
    type="date"
    :disabled="filter.disabled"
    @change-value="emit('changeFilter', $event)"
  />
  <VeeSearchInput
    v-else-if="filter.type === FilterType.Search"
    :name="filter.name"
    :label="filter.label"
    :label-visible="true"
    :placeholder="filter.placeholder"
    :disabled="filter.disabled"
    @change-value="emit('changeFilter', $event)"
  />
  <MultiSelect
    v-else-if="filter.type === FilterType.SelectMultiple"
    class="multi-select-filters fr-select-group"
    :name="filter.name"
    :label="filter.label"
    :options="filter.options"
    :placeholder="filter.placeholder"
    :disabled="filter.disabled"
    @change-value="emit('changeFilter', $event)"
  />
  <VeeSelect
    v-else-if="filter.type === FilterType.SelectOne"
    :name="filter.name"
    :label="filter.label"
    :options="filter.options"
    :disabled="filter.disabled"
    @change-value="emit('changeFilter', $event)"
  />
  <VeeRadioButtons
    v-else-if="filter.type === FilterType.Radio"
    class="filter-radio"
    :class="{ 'filter-radio--as-tag': filter.asTag }"
    :name="filter.name"
    :label="filter.label"
    :options="filter.options"
    :pictos="filter.pictos"
    :as-tag="filter.asTag"
    :no-label="filter.noLabel"
    :rich="filter.rich"
    :disabled="filter.disabled"
    @change-value="emit('changeFilter', $event)"
  />
  <VeeSelect
    v-else
    style="display: none"
    :name="filter.name"
    :label="filter.label"
    :options="filter.options"
    :disabled="filter.disabled"
    @change-value="emit('changeFilter', $event)"
  ></VeeSelect>
</template>

<script lang="ts" setup>
  import { FilterType } from '~/utils/constants/filters'
  import type { FilterProp } from '~/types/filter'

  defineProps<{ filter: FilterProp }>()

  const emit = defineEmits<{
    changeFilter: [value: string | string[]]
  }>()
</script>

<style lang="scss">
  .filter-radio--as-tag {
    .fr-fieldset__element {
      padding-right: 0;
      padding-left: 0.25rem;
    }
  }
</style>
